
package org.wegra.awt;

import java.awt.*;
import javax.swing.JComponent;

/**
 * @author kharaz + Elassad
 */

public class SimpleGridLayout implements LayoutManager {
	
	public static final int DEFAULT_CELL_WIDTH = 40;
	
	public static final int DEFAULT_CELL_HEIGHT = 20;

	private int fCellWidth = DEFAULT_CELL_WIDTH;
	
	private int fCellHeight = DEFAULT_CELL_HEIGHT;

	
	public void setCellSize(int width, int height) {
		fCellWidth = width;
		fCellHeight = height;
	}

	public void layoutContainer(Container target) {
		synchronized (target.getTreeLock()) {
			Grid grid = (Grid)target;
			int row = grid.getRowCount();
			int column = grid.getColumnCount();
			Insets insets = target.getInsets();
			int leftInsets = insets.left;
			int rightInsets = insets.right;
			
			int currentHeight = insets.top;

			for ( int r = 0; r < row; r++ ) {
				for ( int c = 0; c < column; c++ ) {
					Component comp = target.getComponent(r * column + c);
					comp.setBounds( leftInsets + c * (fCellWidth - 1),
									currentHeight,
									fCellWidth,
									fCellHeight );
				}
				currentHeight += fCellHeight - 1;
				((JComponent)target).setPreferredSize( new Dimension(
						leftInsets + rightInsets + column * (fCellWidth  - 1),
						currentHeight + insets.bottom ) );
			}
		}
	}

	public void addLayoutComponent(String arg0, Component arg1) {
	}
	public void removeLayoutComponent(Component arg0) {
	}
	public Dimension preferredLayoutSize(Container arg0) {
		return new Dimension(20, 20);
	}
	public Dimension minimumLayoutSize(Container arg0) {
		return new Dimension(20, 20);
	}

}
