
package seq.awt;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;

import org.wegra.awt.SimpleGrid;

/**
 * @author kharaz + Elassad
 */

public class WorkingMatrixFrame extends JFrame {
	private static final int TAP_SIZE = 6;
	private static final Font DEFAULT_FONT
		= new Font("Courier New", Font.PLAIN, 12);
	
	
	private SimpleGrid fMatrix = new SimpleGrid();
	
	
	public WorkingMatrixFrame() {
		super("erzeugte Matrix");
		
		JScrollPane matrix = new JScrollPane(fMatrix);
		
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());
		contentPane.add(matrix, BorderLayout.CENTER);
		
		setSize(640, 480);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation( screenSize.width - 640, 0);
		
		addWindowListener( new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				setVisible(false);
			}
		});
	}
	
	/**
	 * Sets data to matrix.
	 * 
	 * @param rowSeq row sequence.
	 * @param columnSeq cloumn sequence.
	 * @param matrix working matrix.
	 * @param traceResult trace result on matrix.
	 */
	public void setData(char[] rowSeq, char[] columnSeq,
			int[][] matrix, int[][] traceResult )
	{
		int row = matrix.length;
		int col = matrix[0].length;
		String[] rowHeader = new String[row - 1];
		String[] columnHeader = new String[col - 1];
		for ( int r = 0; r < row - 1; r++ ) {
			rowHeader[r] = String.valueOf(rowSeq[r]);
		}
		
		for ( int c = 0; c < col - 1; c++ ) {
			columnHeader[c] = String.valueOf(columnSeq[c]);
		}
		
		String[][] values = new String[row][col];
		for ( int r = 0; r < row; r++ ) {
			for ( int c = 0; c < col; c++ ) {
				values[r][c] = Integer.toString( matrix[r][c] );
			}
		}

		fMatrix.setElements(rowHeader, columnHeader, values);
		
		for ( int i = 0; i < traceResult.length; i++ ) {
			fMatrix.setCellColor(	traceResult[i][1] + 1,
									traceResult[i][0] + 1,
									Color.red );
		}
		fMatrix.revalidate();
	}
}
